package ed20081.g1.tp1.aleatorios;

import static ed20081.g1.tp1.aleatorios.RandomUtils.gerarCaracterASCIIMaiusculo;
import static ed20081.g1.tp1.aleatorios.RandomUtils.gerarDataNoIntervaloFechado;
import static ed20081.g1.tp1.aleatorios.RandomUtils.gerarDigitoASCII;

import java.util.Calendar;
import java.util.Date;

public abstract class GeradorAleatorio {

	protected Calendar c;
	protected Date dataMinima;
	protected Date dataDeAgora;

	protected GeradorAleatorio() {
		c = Calendar.getInstance();
		c.set(1898, 1, 1, 0, 0, 0);
		dataMinima = c.getTime();
		c.setTimeInMillis(System.currentTimeMillis());
		dataDeAgora = c.getTime();
	}

	protected Date gerarDataAleatoria() {
		return gerarDataNoIntervaloFechado(dataMinima, dataDeAgora);
	}

	protected String gerarPlacaAleatoria() {
		String placa = "";

		for (int i = 0; i < 3; i++)
			placa += gerarCaracterASCIIMaiusculo();

		for (int i = 3; i < 7; i++)
			placa += gerarDigitoASCII();

		return placa;
	}

}
