package ed20081.g1.tp1.aleatorios;

import static ed20081.g1.tp1.aleatorios.RandomUtils.escolherElemento;
import static ed20081.g1.tp1.aleatorios.RandomUtils.gerarIntNoIntervaloFechado;

import java.util.Calendar;

import ed20081.g1.tp1.codigo.TipoVeiculo;
import ed20081.g1.tp1.codigo.Veiculo;
import ed20081.g1.tp1.enums.TiposPesquisa;
import ed20081.g1.tp1.enums.aleatorios.Combustiveis;
import ed20081.g1.tp1.enums.aleatorios.Cores;
import ed20081.g1.tp1.enums.aleatorios.Marcas;
import ed20081.g1.tp1.enums.aleatorios.Modelos;
import ed20081.g1.tp1.persistencia.SerializadorVeiculo;
import ed20081.g1.tp1.pesquisa.GerenciadorDeIndices;
import ed20081.g1.tp1.principal.Opcoes;

public class GeradorAleatorioDeVeiculos extends GeradorAleatorio {

	private final SerializadorVeiculo s;
	private final int anoAtual;
	private final int anoInicial = 1898;

	public GeradorAleatorioDeVeiculos(SerializadorVeiculo serializador) {
		super();
		anoAtual = c.get(Calendar.YEAR);
		s = serializador;
	}

	public void cadastrarAleatoriamenteN(int n) {
		int veiculosInseridos = 0;
		TiposPesquisa tipoPesquisa = Opcoes.obterTipoPesquisa();

		while (veiculosInseridos < n) {

			final String placa = gerarPlacaAleatoria();

			final TipoVeiculo veiculoPesquisado = s.procurarVeiculo(placa, 1000);

			if (veiculoPesquisado == null) {
				final int ano = gerarIntNoIntervaloFechado(anoInicial, anoAtual);
				final String marca = escolherElemento(Marcas.values()).toString();
				final String modelo = escolherElemento(Modelos.values()).toString();
				final String cor = escolherElemento(Cores.values()).toString();
				final String combustivel = escolherElemento(Combustiveis.values()).toString();

				final TipoVeiculo v = new Veiculo(placa, ano, marca, modelo, cor, combustivel);
				s.serializar(v);
				if (tipoPesquisa == TiposPesquisa.INDEXADA)
					GerenciadorDeIndices.adicionarNoIndiceDeVeiculos(v);
				veiculosInseridos++;
			}
		}

	}

}
