package ed20081.g1.tp1.aleatorios;

import java.util.Date;

public abstract class RandomUtils {

	public static Object escolherElemento(Object[] array) {
		final int indice = gerarIntNoIntervaloFechado(0, array.length - 1);
		return array[indice];
	}

	public static boolean gerarBoolean() {
		return Math.random() >= 0.5;
	}

	public static char gerarCaracterASCIIMaiusculo() {
		return (char) gerarIntNoIntervaloFechado(65, 90);
	}

	public static Date gerarDataNoIntervaloFechado(Date min, Date max) {
		final long minEpochOffset = min.getTime();
		final long maxEpochOffset = max.getTime();

		final long instanteSorteado = gerarLongNoIntervaloFechado(minEpochOffset, maxEpochOffset);

		return new Date(instanteSorteado);
	}

	public static char gerarDigitoASCII() {
		return (char) gerarIntNoIntervaloFechado(48, 57);
	}

	public static int gerarIntNoIntervaloFechado(int min, int max) {
		return min + (int) (Math.random() * (max - min + 1));
	}

	public static long gerarLongNoIntervaloFechado(long min, long max) {
		return min + (long) (Math.random() * (max - min + 1));
	}

}
