package ed20081.g1.tp1.codigo;

import java.text.SimpleDateFormat;
import java.util.Date;

public class Sinistro implements TipoSinistro {

	private int codigo;
	private String placa;
	private Date data;
	private String municipio;
	private String estado;
	private String endereco;
	private boolean motoristaEmbriagado;
	private boolean perdaTotal;
	private int vitimasNaoFatais;
	private int vitimasFatais;
	private String descricao;

	public Sinistro(int codigo, String placa, Date data, String municipio, String estado,
			String endereco, boolean motoristaEmbriagado, boolean perdaTotal, int vitimasNaoFatais,
			int vitimasFatais, String descricao) {

		this.codigo = codigo;
		this.placa = placa;
		this.data = data;
		this.municipio = municipio;
		this.estado = estado;
		this.endereco = endereco;
		this.motoristaEmbriagado = motoristaEmbriagado;
		this.perdaTotal = perdaTotal;
		this.vitimasNaoFatais = vitimasNaoFatais;
		this.vitimasFatais = vitimasFatais;
		this.descricao = descricao;
	}

	public boolean equals(Object obj) {
		boolean retorno = false;
		if (obj instanceof Sinistro) {
			final Sinistro outro = (Sinistro) obj;
			retorno = codigo == outro.codigo;
		}

		return retorno;
	}

	public void fixarCodigo(int codigo) {
		this.codigo = codigo;
	}

	public void fixarData(Date data) {
		this.data = data;
	}

	public void fixarDescricao(String descricao) {
		this.descricao = descricao;
	}

	public void fixarEndereco(String endereco) {
		this.endereco = endereco;
	}

	public void fixarEstado(String estado) {
		this.estado = estado;
	}

	public void fixarMotoristaEmbriagado(boolean motoristaEmbriagado) {
		this.motoristaEmbriagado = motoristaEmbriagado;
	}

	public void fixarMunicipio(String municipio) {
		this.municipio = municipio;
	}

	public void fixarPerdaTotal(boolean perdaTotal) {
		this.perdaTotal = perdaTotal;
	}

	public void fixarPlaca(String placa) {
		this.placa = placa;
	}

	public void fixarVitimasFatais(int vitimasFatais) {
		this.vitimasFatais = vitimasFatais;
	}

	public void fixarVitimasNaoFatais(int vitimasNaoFatais) {
		this.vitimasNaoFatais = vitimasNaoFatais;
	}

	public boolean motoristaEmbriagado() {
		return motoristaEmbriagado;
	}

	public int obterCodigo() {
		return codigo;
	}

	public Date obterData() {
		return data;
	}

	public String obterDescricao() {
		return descricao;
	}

	public String obterEndereco() {
		return endereco;
	}

	public String obterEstado() {
		return estado;
	}

	public String obterMunicipio() {
		return municipio;
	}

	public String obterPlaca() {
		return placa;
	}

	public int obterVitimasFatais() {
		return vitimasFatais;
	}

	public int obterVitimasNaoFatais() {
		return vitimasNaoFatais;
	}

	public boolean perdaTotal() {
		return perdaTotal;
	}

	public String toString() {
		final SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
		final String dataHumana = sdf.format(data);
		final String perdaTotalHumano = perdaTotal ? "Sim" : "No";
		final String embriagadoHumano = motoristaEmbriagado ? "Sim" : "No";

		return "(Cdigo: " + codigo + ", Placa: " + placa + ", Data: " + dataHumana
				+ ", Municpio: " + municipio + ", Estado: " + estado + ", Endereo: " + endereco
				+ ", Motorista embriagado: " + embriagadoHumano + ", Perda total: "
				+ perdaTotalHumano + ", Vtimas no-fatais: " + vitimasNaoFatais
				+ ", Vtimas fatais: " + vitimasFatais + ", Descrio: " + descricao + ")";

	}
}
