package ed20081.g1.tp1.persistencia;

import ine5408.pp.Iterador;
import ed20081.g1.tp1.codigo.Sinistro;
import ed20081.g1.tp1.codigo.TipoSinistro;
import ed20081.g1.tp1.codigo.TipoVeiculo;
import ed20081.g1.tp1.util.ListaDuplamenteEncadeada;

public class SerializadorPesquisa extends Serializador {

	private static SerializadorPesquisa instanciaUnica;

	public static SerializadorPesquisa obterInstancia() {
		if (instanciaUnica == null)
			instanciaUnica = new SerializadorPesquisa();

		return instanciaUnica;
	}

	private final Tradutor tradutor = Tradutor.obterInstancia();
	private final int tamanhoDeUmVeiculo = tradutor.obterTamanhoVeiculo();

	private final int tamanhoDeUmSinistro = tradutor.obterTamanhoSinistro();

	public void serializarSinistro(TipoSinistro encontrado) {
		fixarTamanhoDoSerializado(tamanhoDeUmSinistro);
		limparArquivo();
		final String traduzido = tradutor.formatarSinistro(encontrado);
		serializar(traduzido);
	}

	public void serializarSinistros(ListaDuplamenteEncadeada<Sinistro> encontrados) {
		fixarTamanhoDoSerializado(tamanhoDeUmSinistro);
		limparArquivo();
		for (Iterador<Sinistro> iter = encontrados.retorneIterador(); iter.temMais();) {
			final String traduzido = tradutor.formatarSinistro(iter.retorneProximo());
			serializar(traduzido);
		}

	}

	public void serializarVeiculo(TipoVeiculo encontrado) {
		fixarTamanhoDoSerializado(tamanhoDeUmVeiculo);
		limparArquivo();
		final String traduzido = tradutor.formatarVeiculo(encontrado);
		serializar(traduzido);
	}

}
