package ed20081.g1.tp1.pesquisa;

import ine5408.lineares.Lista;
import ed20081.g1.tp1.codigo.TipoSinistro;
import ed20081.g1.tp1.codigo.TipoVeiculo;
import ed20081.g1.tp1.persistencia.SerializadorSinistro;
import ed20081.g1.tp1.persistencia.SerializadorVeiculo;
import ed20081.g1.tp1.util.FuncaoGModulo;
import ed20081.g1.tp1.util.ListaDuplamenteEncadeada;
import ed20081.g1.tp1.util.TabelaDeHash;

public class GerenciadorDeIndices {

	private static ine5408.th.TabelaDeHash<String, Integer> indiceVeiculos;
	private static ine5408.th.TabelaDeHash<Integer, Integer> indiceSinistrosCodigo;
	private static ine5408.th.TabelaDeHash<String, Lista<Integer>> indiceSinistrosPlaca;

	private static final SerializadorVeiculo sVeiculos = SerializadorVeiculo.obterInstancia();
	private static final SerializadorSinistro sSinistros = SerializadorSinistro.obterInstancia();

	public static void adicionarNoIndiceDeVeiculos(TipoVeiculo v) {
		int posicao = (int) sVeiculos.contarEntradas();
		indiceVeiculos.insira(v.obterPlaca(), posicao);
	}

	public static void adicionarNosIndicesDeSinistro(TipoSinistro sin) {
		int posicao = (int) sSinistros.contarEntradas();
		indiceSinistrosCodigo.insira(sin.obterCodigo(), posicao);

		final String placa = sin.obterPlaca();
		Lista<Integer> posicoes = indiceSinistrosPlaca.retorne(placa);
		if (posicoes == null) {
			posicoes = new ListaDuplamenteEncadeada<Integer>();
			indiceSinistrosPlaca.insira(placa, posicoes);
		}

		posicoes.insiraNoFim(posicao);
	}

	public static ine5408.th.TabelaDeHash<Integer, Integer> obterIndiceSinistrosCodigo() {
		return indiceSinistrosCodigo;
	}

	public static ine5408.th.TabelaDeHash<String, Lista<Integer>> obterIndiceSinistrosPlaca() {
		return indiceSinistrosPlaca;
	}

	public static ine5408.th.TabelaDeHash<String, Integer> obterIndiceVeiculos() {
		return indiceVeiculos;
	}

	private static void popularIndiceDeVeiculos() {
		indiceVeiculos = new TabelaDeHash<String, Integer>(new FuncaoGModulo(50000));
		String[] lidos;

		int posicao = 1;
		while (!sVeiculos.acabouArquivo()) {
			lidos = sVeiculos.lerDoArquivo(1000);
			for (String lido : lidos)
				indiceVeiculos.insira(lido.substring(0, 7), posicao++);
		}

	}

	public static void popularIndices() {
		// TODO Escolher FuncaoG
		popularIndiceDeVeiculos();
		popularIndicesDeSinistros();

	}

	private static void popularIndicesDeSinistros() {
		indiceSinistrosCodigo = new TabelaDeHash<Integer, Integer>(new FuncaoGModulo(50000));
		indiceSinistrosPlaca = new TabelaDeHash<String, Lista<Integer>>(new FuncaoGModulo(50000));

		String[] lidos;
		int posicao = 1;
		Lista<Integer> posicoes;
		while (!sSinistros.acabouArquivo()) {
			lidos = sSinistros.lerDoArquivo(1000);
			for (String lido : lidos) {
				String placa = lido.substring(7, 14);

				indiceSinistrosCodigo.insira(Integer.parseInt(lido.substring(0, 6)), posicao);

				posicoes = indiceSinistrosPlaca.retorne(placa);
				if (posicoes == null) {
					posicoes = new ListaDuplamenteEncadeada<Integer>();
					indiceSinistrosPlaca.insira(placa, posicoes);
				}
				posicoes.insiraNoFim(posicao);

				posicao++;
			}
		}

	}

}
