package ed20081.g1.tp1.principal;

import static ed20081.g1.tp1.util.StringUtils.imprimirStringConvertida;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.RandomAccessFile;

import ed20081.g1.tp1.enums.Modos;
import ed20081.g1.tp1.enums.TiposPesquisa;

public class Interpretador {

	private static final String prefixoPadraoDosArquivos = "./seguradora";

	public static void exibirAjuda() {
		final String EOL = System.getProperty("line.separator");

		final String ajuda = "Trabalho Prtico 1 - Grupo 1 - Estruturas de Dados 2008/1"
				+ EOL
				+ "Para usar o programa voc DEVE selecionar UM modo de operao"
				+ EOL
				+ "Abaixo esto as possveis opes de linha de comando e sua funo: "
				+ EOL
				+ "\t -cv    ==> Modo de cadastro manual de veculos."
				+ EOL
				+ "\t -cs    ==> Modo de cadastro manual de sinistros."
				+ EOL
				+ "\t -Cv N  ==> Cadastro de N veculos gerados aleatoriamente"
				+ EOL
				+ "\t -Cs N  ==> Cadastro de N sinistros gerados aleatoriamente"
				+ EOL
				+ "\t -pv    ==> Pesquisa por um veculo a partir de sua placa."
				+ EOL
				+ "\t -ps    ==> Pesquisa por um sinistro a partir de seu cdigo."
				+ EOL
				+ "\t -pp    ==> Pesquisa por sinistros relacionados  uma placa."
				+ EOL
				+ "\t -mv    ==> Alterar dados de um veculo."
				+ EOL
				+ "\t -ms    ==> Alterar dados de um sinistro."
				+ EOL
				+ "\t -rs    ==> Remover sinistro."
				+ EOL
				+ "\t -rv    ==> Remover veculo."
				+ EOL
				+ "\t -nv    ==> Exibir nmero de veculos."
				+ EOL
				+ "\t -ns    ==> Exibir nmero de sinistros."
				+ EOL
				+ "\t -ea \"endereo da pasta onde sero salvos os arquivos\" \"nome dos arquivos a serem criados\""
				+ EOL + "Se os arquivos escolhidos no existirem, eles sero criados";
		imprimirStringConvertida(ajuda);
	}

	public static void interpretar(String[] linhaComando) {
		if (linhaComando.length > 0) {
			try {
				for (int i = 0; i < linhaComando.length; i++) {
					final String opcao = linhaComando[i];

					if (opcao.equals("-cv"))
						Opcoes.fixarModo(Modos.CADASTRO);
					else if (opcao.equals("-cs"))
						Opcoes.fixarModo(Modos.CADASTROSINISTRO);
					else if (opcao.equals("-Cv")) {
						Opcoes.fixarModo(Modos.CADASTROALEATORIOVEICULO);
						try {
							Opcoes.fixarQtdRegsAleatorios(Integer.valueOf(linhaComando[i + 1]));
						} catch (final NumberFormatException e) {
							imprimirStringConvertida("O parmetro digitado no  um nmero!");
						}
					} else if (opcao.equals("-pv"))
						Opcoes.fixarModo(Modos.PESQUISADEVEICULO);
					else if (opcao.equals("-Cs")) {
						Opcoes.fixarModo(Modos.CADASTROALEATORIOSINISTRO);
						try {
							Opcoes.fixarQtdRegsAleatorios(Integer.valueOf(linhaComando[i + 1]));
						} catch (final NumberFormatException e) {
							imprimirStringConvertida("O parmetro digitado no  um nmero!");
						}
					} else if (opcao.equals("-ps"))
						Opcoes.fixarModo(Modos.PESQUISADESINISTRO);
					else if (opcao.equals("-pp"))
						Opcoes.fixarModo(Modos.PESQUISADESINISTROSDEUMVEICULO);
					else if (opcao.equals("-mv"))
						Opcoes.fixarModo(Modos.ALTERARDADOSDEUMVEICULO);
					else if (opcao.equals("-ms"))
						Opcoes.fixarModo(Modos.ALTERARDADOSDEUMSINISTRO);
					else if (opcao.equals("-rs"))
						Opcoes.fixarModo(Modos.REMOVERSINISTRO);
					else if (opcao.equals("-rv"))
						Opcoes.fixarModo(Modos.REMOVERVEICULO);
					else if (opcao.equals("-nv"))
						Opcoes.fixarModo(Modos.NUMEROVEICULOS);
					else if (opcao.equals("-ns"))
						Opcoes.fixarModo(Modos.NUMEROSINISTROS);
				}
			} catch (final ArrayIndexOutOfBoundsException e) {
				imprimirStringConvertida("A opo -C deve ser sucedida de parmetro");
				System.exit(0);
			}

			parsearNomesDeArquivos(linhaComando);
			parsearTipoPesquisa(linhaComando);
		}

	}

	private static void parsearNomesDeArquivos(String[] linhaComando) {
		try {
			for (int i = 0; i < linhaComando.length; i++) {
				String opcao = linhaComando[i];
				if (opcao.equals("-ea")) {
					final String nomePadrao = linhaComando[i + 1]
							+ System.getProperty("file.separator") + linhaComando[i + 2];
					Opcoes.fixarPrefixoDosArquivos(nomePadrao);
					testarDiretorios();
				}
			}

			Opcoes.fixarPrefixoDosArquivos(prefixoPadraoDosArquivos);

		} catch (final ArrayIndexOutOfBoundsException e) {
			imprimirStringConvertida("A opo -ea deve ser sucedida de parmetro");
			System.exit(0);
		}
	}

	private static void parsearTipoPesquisa(String[] linhaComando) {
		try {
			for (int i = 0; i < linhaComando.length; i++) {
				String opcao = linhaComando[i];
				if (opcao.equals("-tp")) {
					String tipo = linhaComando[i + 1];
					if (tipo.equals("ind"))
						Opcoes.fixarTipoPesquisa(TiposPesquisa.INDEXADA);
					else
						Opcoes.fixarTipoPesquisa(TiposPesquisa.SEQUENCIAL);
				}
			}

			Opcoes.fixarTipoPesquisa(TiposPesquisa.SEQUENCIAL);

		} catch (ArrayIndexOutOfBoundsException e) {
			imprimirStringConvertida("A opo -tp deve ser sucedida de parmetro");
			System.exit(0);
		}
	}

	private static void testarDiretorios() {
		final File f = new File(Opcoes.obterArquivoPesquisa());
		final File fa = new File(Opcoes.obterArquivoSinistros());
		final File fb = new File(Opcoes.obterArquivoVeiculos());

		try {
			new RandomAccessFile(f, "rw");
			new RandomAccessFile(fa, "rw");
			new RandomAccessFile(fb, "rw");
		} catch (final FileNotFoundException e) {
			imprimirStringConvertida("Diretrio no existe!");
		}

	}

}
