package ed20081.g1.tp1.principal.ui;

import static ed20081.g1.tp1.util.StringUtils.imprimirStringConvertida;

import java.util.Scanner;

import ed20081.g1.tp1.codigo.TipoVeiculo;
import ed20081.g1.tp1.excecoes.ExcecaoCampoInvalido;
import ed20081.g1.tp1.persistencia.SerializadorSinistro;
import ed20081.g1.tp1.persistencia.SerializadorVeiculo;
import ed20081.g1.tp1.validacao.ValidadorDeVeiculos;

public class ModificadorDeVeiculos {

	private static ModificadorDeVeiculos instanciaUnica;

	public static ModificadorDeVeiculos obterInstancia() {
		if (instanciaUnica == null)
			instanciaUnica = new ModificadorDeVeiculos();
		return instanciaUnica;
	}

	private final Scanner s = new Scanner(System.in);

	private final ValidadorDeVeiculos validadorVeiculos = ValidadorDeVeiculos.obterInstancia();

	private void modificarAno(TipoVeiculo antigo) {
		imprimirStringConvertida("Ano antigo: " + antigo.obterAnoDeFabricacao() + "\n Novo ano:");
		int ano;
		final String lido = s.nextLine();
		if (!lido.equals(""))
			try {
				ano = Integer.valueOf(lido);
				validadorVeiculos.validarAno(ano);
				antigo.fixarAno(ano);
			} catch (final NumberFormatException e) {
				imprimirStringConvertida("O valor digitado no  um nmero!");
				modificarAno(antigo);
			} catch (final ExcecaoCampoInvalido e) {
				imprimirStringConvertida(e.getMessage());
				modificarAno(antigo);
			}

	}

	private void modificarCombustivel(TipoVeiculo antigo) {
		imprimirStringConvertida("Combustvel antigo: " + antigo.obterCombustivel()
				+ "\n Novo combustvel:");

		final String combustivel = s.nextLine();
		if (!combustivel.equals(""))
			antigo.fixarCombustivel(combustivel);

	}

	private void modificarCor(TipoVeiculo antigo) {
		imprimirStringConvertida("Cor antiga: " + antigo.obterCor() + "\n Nova cor:");

		final String cor = s.nextLine();
		if (!cor.equals(""))
			antigo.fixarCor(cor);

	}

	private void modificarMarca(TipoVeiculo antigo) {
		imprimirStringConvertida("Marca antiga: " + antigo.obterMarca() + "\n Nova marca:");

		final String marca = s.nextLine();
		if (!marca.equals(""))
			antigo.fixarMarca(marca);

	}

	private void modificarModelo(TipoVeiculo antigo) {
		imprimirStringConvertida("Modelo antigo: " + antigo.obterModelo() + "\n Novo modelo:");

		final String modelo = s.nextLine();
		if (!modelo.equals(""))
			antigo.fixarModelo(modelo);
	}

	private void modificarPlaca(TipoVeiculo antigo) {
		imprimirStringConvertida("Placa antiga: " + antigo.obterPlaca() + "\n Nova placa");

		final String placa = s.nextLine();

		if (!placa.equals("")) {
			final SerializadorVeiculo serializadorDeVeiculo = SerializadorVeiculo.obterInstancia();

			try {
				validadorVeiculos.validarPlaca(placa);
				if (serializadorDeVeiculo.procurarVeiculo(placa, 1000) != null) {
					imprimirStringConvertida("J existe um veculo com esta placa no arquivo!");
					modificarPlaca(antigo);
				} else {
					final String placaAntiga = antigo.obterPlaca();
					SerializadorSinistro.obterInstancia().alterarSinistrosAssociados(placaAntiga,
							placa, 1000);
					antigo.fixarPlaca(placa);
				}
			} catch (final ExcecaoCampoInvalido e) {
				imprimirStringConvertida(e.getMessage());
				modificarPlaca(antigo);
			}

		}

	}

	public void modificarVeiculo(TipoVeiculo antigo) {
		modificarPlaca(antigo);
		modificarAno(antigo);
		modificarMarca(antigo);
		modificarModelo(antigo);
		modificarCor(antigo);
		modificarCombustivel(antigo);

	}

}
