package ed20081.g1.tp1.testes;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import ed20081.g1.tp1.enums.Modos;
import ed20081.g1.tp1.enums.TiposPesquisa;
import ed20081.g1.tp1.principal.Opcoes;
import ed20081.g1.tp1.util.FuncaoGMiddleSquare;
import ed20081.g1.tp1.util.FuncaoGModulo;

public class TestesDaClasseOpcoes {

	@Test
	public void testeFixarFuncaoG() {
		FuncaoGMiddleSquare middle = new FuncaoGMiddleSquare(32, 12);
		Opcoes.fixarFuncaoG(middle);
		assertEquals(middle, Opcoes.obterFuncaoG());

		Opcoes.fixarFuncaoG(new FuncaoGModulo(4000));
		assertEquals(middle, Opcoes.obterFuncaoG());
	}

	@Test
	public void testeFixarModo() {
		Opcoes.fixarModo(Modos.NUMEROSINISTROS);
		assertEquals(Modos.NUMEROSINISTROS, Opcoes.obterModo());

		Opcoes.fixarModo(Modos.NUMEROVEICULOS);
		assertEquals(Modos.NUMEROSINISTROS, Opcoes.obterModo());
	}

	@Test
	public void testeFixarPrefixoDosArquivos() {
		Opcoes.fixarPrefixoDosArquivos("arqVe1");
		assertEquals("arqVe1-v.txt", Opcoes.obterArquivoVeiculos());
		assertEquals("arqVe1-s.txt", Opcoes.obterArquivoSinistros());
		assertEquals("arqVe1-p.txt", Opcoes.obterArquivoPesquisa());

		Opcoes.fixarPrefixoDosArquivos("arqVe2");
		assertEquals("arqVe1-v.txt", Opcoes.obterArquivoVeiculos());
		assertEquals("arqVe1-s.txt", Opcoes.obterArquivoSinistros());
		assertEquals("arqVe1-p.txt", Opcoes.obterArquivoPesquisa());
	}

	@Test
	public void testeFixarQtdRegsAleatorios() {
		Opcoes.fixarQtdRegsAleatorios(10500);
		assertEquals(10500, Opcoes.obterQtdRegsAleatorios());

		Opcoes.fixarQtdRegsAleatorios(20250);
		assertEquals(10500, Opcoes.obterQtdRegsAleatorios());
	}

	@Test
	public void testeFixarTipoPesquisa() {
		Opcoes.fixarTipoPesquisa(TiposPesquisa.INDEXADA);
		assertEquals(TiposPesquisa.INDEXADA, Opcoes.obterTipoPesquisa());

		Opcoes.fixarTipoPesquisa(TiposPesquisa.SEQUENCIAL);
		assertEquals(TiposPesquisa.INDEXADA, Opcoes.obterTipoPesquisa());
	}

}
