package ed20081.g1.tp1.testes;

import org.junit.Test;

import ed20081.g1.tp1.excecoes.CampoVazio;
import ed20081.g1.tp1.excecoes.PlacaInvalida;
import ed20081.g1.tp1.validacao.Validador;

public abstract class TestesDeValidador {

	protected Validador validador;

	@Test(expected = PlacaInvalida.class)
	public void umaPlacaComAlgumDgitoNos3PrimeirosCaracteresInvlida() throws PlacaInvalida,
			CampoVazio {
		validador.validarPlaca("3ab1234");
	}

	@Test(expected = PlacaInvalida.class)
	public void umaPlacaComLetraNos4DgitosFinaisInvlida() throws PlacaInvalida, CampoVazio {
		validador.validarPlaca("abc123a");
	}

	@Test(expected = PlacaInvalida.class)
	public void umaPlacaComMaisDe7CaracteresInvlida() throws PlacaInvalida, CampoVazio {
		validador.validarPlaca("abc63638");
	}

	@Test(expected = PlacaInvalida.class)
	public void umaPlacaComMenosDe7CaracteresInvlida() throws PlacaInvalida, CampoVazio {
		validador.validarPlaca("abc");
	}

	@Test
	public void umaPlacaQueSegueALeiDeTrnsitoVlida() throws PlacaInvalida, CampoVazio {
		validador.validarPlaca("cdf1010");
	}

	@Test(expected = PlacaInvalida.class)
	public void umaPlacaVaziaCausaExceoDePlacaInvlida() throws PlacaInvalida {
		validador.validarPlaca("");
	}

	@Test(expected = CampoVazio.class)
	public void umCampoNaoVazioJogaUmaExcecaoSeEstiverVazio() throws CampoVazio {
		validador.validarCampoNaoVazio("");
	}

}
