package ed20081.g1.tp1.testes.sinistro;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

import java.text.ParseException;
import java.text.SimpleDateFormat;

import org.junit.Test;

import ed20081.g1.tp1.codigo.Sinistro;
import ed20081.g1.tp1.codigo.TipoSinistro;

public class TestesDeSinistro {

	private final SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyy");

	@Test
	public void doisSinistrosComCodigosDiferentesNaoSaoIguais() throws ParseException {
		final TipoSinistro s1 = new Sinistro(12, "ABC1234", sdf.parse("01/01/2001"), "Brusque",
				"SC", "ubk", false, false, 0, 0, "oafasofnsaofn");
		final TipoSinistro s2 = new Sinistro(13, "ABC1234", sdf.parse("01/01/2001"), "Brusque",
				"SC", "ubk", false, false, 0, 0, "oafasofnsaofn");

		assertFalse(s1.equals(s2));
	}

	@Test
	public void doisSinistrosComMesmoCodigoSaoIguais() throws ParseException {
		final TipoSinistro s1 = new Sinistro(12, "FHJ6523", sdf.parse("12/04/2004"),
				"Porto Alegre", "RS", "Avenida Farrapos, 3400", true, true, 2, 1,
				"Motorista bebeu mais ou menos, no pra tudo isso...");
		final TipoSinistro s2 = new Sinistro(12, "ABC1234", sdf.parse("01/01/2001"), "Brusque",
				"SC", "ubk", false, false, 0, 0, "oafasofnsaofn");

		assertEquals(s2, s1);
	}

	@Test
	public void testeToString() throws ParseException {
		final TipoSinistro s = new Sinistro(12, "FHJ6523", sdf.parse("12/04/2004"), "Porto Alegre",
				"RS", "Avenida Farrapos, 3400", true, true, 2, 1,
				"Motorista bebeu mais ou menos, no pra tudo isso...");
		final String esperada = "(Cdigo: 12, Placa: FHJ6523, Data: 12/04/2004, Municpio: Porto Alegre, Estado: RS, Endereo: Avenida Farrapos, 3400, Motorista embriagado: Sim, Perda total: Sim, Vtimas no-fatais: 2, Vtimas fatais: 1, Descrio: Motorista bebeu mais ou menos, no pra tudo isso...)";

		assertEquals(esperada, s.toString());
	}

}
