package ed20081.g1.tp1.testes.tradutor;

import static org.junit.Assert.assertEquals;

import java.text.ParseException;
import java.text.SimpleDateFormat;

import org.junit.Before;
import org.junit.Test;

import ed20081.g1.tp1.codigo.Sinistro;
import ed20081.g1.tp1.codigo.TipoSinistro;
import ed20081.g1.tp1.codigo.TipoVeiculo;
import ed20081.g1.tp1.codigo.Veiculo;
import ed20081.g1.tp1.persistencia.Tradutor;

public class TestesDoTradutor {

	private Tradutor t;
	private SimpleDateFormat sdf;

	@Before
	public void inicia() {
		t = Tradutor.obterInstancia();
		sdf = new SimpleDateFormat("dd/MM/yyyy");
	}

	@Test
	public void testeFormatarSinistro() throws ParseException {
		final TipoSinistro s = new Sinistro(15, "MEU0978", sdf.parse("12/10/2000"), "Chapec",
				"SC", "Rua B - 173", true, true, 2, 1, "Bateu de frente com caminho");

		final String esperado = "000015MEU097812/10/2000Chapec                       SCRua B - 173                                       simsim00020001Bateu de frente com caminho                                                                                                                                                                            "
				+ System.getProperty("line.separator");

		assertEquals(esperado, t.formatarSinistro(s));
	}

	@Test
	public void testeFormatarVeiculo() {
		final TipoVeiculo veiculo = new Veiculo("WTF6666", 1966, "GM", "Hummer", "Laranja",
				"Querosene");

		final String esperado = "WTF66661966GM        Hummer              Laranja        Querosene           "
				+ System.getProperty("line.separator");

		assertEquals(esperado, t.formatarVeiculo(veiculo));
	}
}
