package ed20081.g1.tp1.testes.veiculo;

import java.util.Calendar;

import org.junit.Before;
import org.junit.Test;

import ed20081.g1.tp1.excecoes.veiculos.AnoInvalido;
import ed20081.g1.tp1.testes.TestesDeValidador;
import ed20081.g1.tp1.validacao.ValidadorDeVeiculos;

public class TestesDeValidadorVeiculo extends TestesDeValidador {

	private ValidadorDeVeiculos validadorDeVeiculos;

	@Test(expected = AnoInvalido.class)
	public void anoAnteriorA1885Invlido() throws AnoInvalido {
		validadorDeVeiculos.validarAno(1884);
	}

	@Test(expected = AnoInvalido.class)
	public void anoComMaisDeQuatroDgitosInvlido() throws AnoInvalido {
		validadorDeVeiculos.validarAno(19812);
	}

	@Test(expected = AnoInvalido.class)
	public void anoComMenosDeQuatroDgitosInvlido() throws AnoInvalido {
		validadorDeVeiculos.validarAno(123);
	}

	@Test(expected = AnoInvalido.class)
	public void anoPosteriorAoAtualInvlido() throws AnoInvalido {
		final Calendar c = Calendar.getInstance();
		validadorDeVeiculos.validarAno(c.get(Calendar.YEAR) + 1);
	}

	@Before
	public void iniciar() {
		validador = validadorDeVeiculos = ValidadorDeVeiculos.obterInstancia();
	}

	@Test
	public void umAnoEntre1898EAtualVlido() throws AnoInvalido {
		validadorDeVeiculos.validarAno(1950);
	}

}
