package ed20081.g1.tp1.validacao;

import ed20081.g1.tp1.excecoes.CampoVazio;
import ed20081.g1.tp1.excecoes.PlacaInvalida;

public class Validador {

	private static Validador instanciaUnica;

	public static Validador obterInstancia() {
		if (instanciaUnica == null)
			instanciaUnica = new Validador();
		return instanciaUnica;
	}

	protected Validador() {
	}

	private boolean letrasDaPlacaCorretas(String placa) {
		boolean letrasEstaoCertas = true;
		final char[] letras = new char[3];
		placa.getChars(0, 3, letras, 0);

		for (final char c : letras)
			if (!Character.isLetter(c))
				letrasEstaoCertas = false;

		return letrasEstaoCertas;
	}

	private boolean numerosDaPlacaCorretos(String placa) {
		boolean numerosEstaoCertos = true;
		final char[] numeros = new char[4];
		placa.getChars(3, 7, numeros, 0);

		for (final char c : numeros)
			if (!Character.isDigit(c))
				numerosEstaoCertos = false;

		return numerosEstaoCertos;
	}

	private boolean tamanhoDaPlacaCorreto(String placa) {
		return placa.length() == 7;
	}

	public void validarCampoNaoVazio(String campo) throws CampoVazio {
		if (campo.length() == 0)
			throw new CampoVazio();
	}

	public void validarPlaca(String placa) throws PlacaInvalida {
		if (!tamanhoDaPlacaCorreto(placa))
			throw new PlacaInvalida();

		if (!letrasDaPlacaCorretas(placa) || !numerosDaPlacaCorretos(placa))
			throw new PlacaInvalida();
	}
}